/*
Programm: Aufg.2
Zweck:    rekursive Berechnung der Ackermann-Funktion
Aufgabe:  Entspricht der Aufgabe 2 der Uebungsaufgaben zur Vorlesung 
          "Programmierung 2" bei Prof. Hoffmann.
Autor:    Mattias Ansorg <ansis@gmx.de>
Lizenz:   public domain
Datum:    2002-09-05
*/

#include <iostream>
using namespace std;

unsigned long int ackermann_count;

int ackermann(int x, int y) {
  //PRE: x>=0, y>=0
  ackermann_count++;
  if (x==0) return y+1;
  if (y==0) return ackermann(x-1,1);
  return ackermann(x-1,ackermann(x,y-1));
}

int main() {
  while (true) {
    ackermann_count=0;
    int x,y;
    cout << "Wert fr x: ";
    cin >> x;
    cout << "Wert fr y: ";
    cin >> y;
    cout << "Ackermann(" << x << "," << y << "): " << ackermann(x,y) << endl;
    cout << "Bentigte Funktionsaufrufe: " << ackermann_count << endl << endl;
  }
}
