/*
Programm: Aufg.13
Zweck:    Kontrolle der Korrektur der Funktion stringop der Aufgabenstellung 
Aufgabe:  Entspricht der Aufgabe 13 der Uebungsaufgaben zur Vorlesung 
          "Programmierung 2" bei Prof. Hoffmann.
Autor:    Mattias Ansorg <ansis@gmx.de>
Lizenz:   public domain
Datum:    2002-09-08
*/

#include <iostream>
#include <string>
using namespace std;

string stringop(string s) {
  char r[100];
  s.copy(r,s.length());
  int r_length = s.length();
  int k=0;
  for (int i=0; i<r_length; i++) {
    char c=r[i];
    if (c>='a' && c<='z')
      c='A'+c-'a'; //Klein- in Grossbuchstaben wandeln
    if (c>='A' && c<='Z')
      r[k++]=c; //alle (Gross-)Buchstaben in r speichern
  }
  for (int i=0; i<k; i++) { //fuer jedes Zeichen r[0]..r[k-1]:
    int n=i+1;
    char c=r[i];
    for (int m=i+1; m<k; m++) {
      //fuer jedes Zeichen r[i+1] .. r[k-1]:
      char d=r[m];
      if (d!=c) //eliminiere r[m], wenn identisch r[i]
        r[n++]=d;
    }
    k=n; //verkuerzte Laenge nach Eliminierung
  }
  string returnstring(r);
  return returnstring.substr(0,k); //auf k Zeichen Laenge kuerzen
}

int main () {
  string teststring;
  cout << "Bitte Zeichenkette zum Test von stringop eingeben: ";
  getline(cin,teststring); //nicht nur bis zum ersten Leerzeichen!
  cout << "Ergebnis von stringop :" << stringop(teststring) << endl;
}
