/*
Programm: Aufg.SS99-00.4
Zweck:    Kontrolle der Loesung mit dem Rechner
Aufgabe:  Entspricht der Aufgabe 4 in der Klausur "Programmierung II" aus 
          dem Sommersemester 1998 bei Prof. Hoffmann.  
Autor:    Mattias Ansorg <ansis@gmx.de>
Lizenz:   public domain
Datum:    2002-09-23
*/

#include <stdio.h>
#include <iostream>

int main() {
  typedef struct {
    char *title;
    int x0, y0;
    int b,h;
  } WINPAR;

  //Der Name eines Typs kann unmittelbar nach seinem Auftreten benutzt werden,
  //und nicht erst, nachdem seine Deklaration komplett ist:
  struct ELEMENT1 {
    ELEMENT1 *pre, *suc;
    WINPAR winpr;
  }; 

  //In der Aufgabe gefordert ist jedoch die Verwendung von typedef; hier werden 
  //zwei Namen fr denselben Typ vergeben: e (normale struct-Typdeklaration) und 
  //ELEMENT2 (typedef-Typdeklaration).
  typedef struct e {
    e *pre, *suc;
    WINPAR winpr;
  } ELEMENT2;
} 
